//
// Created by Yannis Goore on 2019-05-10.
//
#include <stdio.h>
#include <time.h>
#include <allegro5/allegro.h>
#include <stdbool.h>
#include <allegro5/allegro_primitives.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_image.h>
#include <allegro5/allegro_audio.h>
#ifndef ALEGROCARRE_EXPLOSION_H


#define ALEGROCARRE_EXPLOSION_H
typedef struct {
    int x;
    int y;
    int tx;
    int ty;
    bool actif;
    int maxFrame;
    int curFrame;
    int frameCount;
    int frameDelay;
    int frameWidth;
    int frameHeight;
    int animationColumns;
    int animationDirection;
    ALLEGRO_BITMAP *image;
} explosion;
void updateExplosions(explosion explosions[], int nbexplo);
void drawExplosions(explosion explosions[], int nbexplos);
void startExplosions(explosion explosions[], int size, int x, int y);
void initExplosions(explosion explosions[], int nbexplos, ALLEGRO_BITMAP*image);
#endif //ALEGROCARRE_EXPLOSION_H
