//
// Created by Yannis Goore on 2019-05-09.
//
#include <stdio.h>
#include <time.h>
#include <allegro5/allegro.h>
#include <stdbool.h>
#include <allegro5/allegro_primitives.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_image.h>
#include <allegro5/allegro_audio.h>
#include "vaisseau.h"
#include "Explosion.h"
#include "BOSS .h"
#include "ennemis.h"
#include "SAMPLES.h"

#define NB_MAX_ETOILES 250
#define SCREEN_WIDTH 2400
#define SCREEN_HEIGHT 1200
#define NOIR al_map_rgb(0,0,0)
#define NB_MAX_ENNEMIS 10
#define NB_MAX_MISSILES 12
#define NB_MAX_EXPLOSIONS 10
#define NB_MAX_BONUS 5
#define NB_MAX_ENNEMIES_FIXES_LVL1  10
#define nbSample 8
#ifndef ALEGROCARRE_MISSILES_H
#define ALEGROCARRE_MISSILES_H



typedef struct {
    int x;
    int y;
    int tx;
    int ty;
    int v;
    bool actif;
    ALLEGRO_BITMAP*imageE;
    ALLEGRO_BITMAP*imageA;
    ALLEGRO_BITMAP*imageF;
} missile;
void init_missiles(missile missiles[]);
void affiche_missiles(missile missiles[]);
void avance_missiles(missile missiles[]);
void avance_missileE(missile missiles[]);
void lancement_missile(vaisseau *vaisseau, missile missiles[]);
void lancement_missileEnnemi(ennemisfix ennemisFixes[], missile missiles[]);
void collison_missilLEnnemi_VAISSEAU(missile missiles[],vaisseau*vaisseau,explosion explosions[]);
void drawmissileEnnemi(missile missiles[]);
void collision_missile(missile missiles[], ennemi ennemis[], vaisseau *vaisseau,explosion explosions[],BOSSFINAL*BOSSFINAL);
void collision_missille_vaisseau_ennemisfixes(missile missiles[],vaisseau *vaisseau,explosion explosions[],ennemisfix ennemisfixes [] );
void collision_missile_NIV2(missile missiles[], ennemi ennemis[], vaisseau *vaisseau,explosion explosions[],BOSSFINAL*BOSSFINAL);
void start_missile_BOSS(BOSSFINAL*BOSSFINAL,missile missiles[] );
void collision_MISSILE_E(missile missiles[],vaisseau*vaisseau,explosion explosions[]);
void drawMissile(missile missiles[]);
#endif //ALEGROCARRE_MISSILES_H
