#include <stdio.h>
#include <time.h>
#include <allegro5/allegro.h>
#include <stdbool.h>
#include <allegro5/allegro_primitives.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_image.h>
#include <allegro5/allegro_audio.h>
#include "ennemis.h"
#include "BOSS .h"
#include "MENU.h"
#include "MENU.c"
#include "Explosion.h"
#include "BONUS.h"
#include "MISSILES.h"
#include "vaisseau.h"
#include "BACKGROUND.h"
#include "SAMPLES.h"
#include "allegro5/allegro_acodec.h"


#define SCREEN_WIDTH 2400
#define SCREEN_HEIGHT 1200
#define NOIR al_map_rgb(0,0,0)
#define NB_MAX_ENNEMIS 10
#define NB_MAX_MISSILES 12
#define NB_MAX_EXPLOSIONS 10
#define NB_MAX_BONUS 5
#define NB_MAX_ENNEMIES_FIXES_LVL1  10


enum KEYS {
    UP, RIGHT, LEFT, DOWN, SPACE, KEY_MAX
};
bool key[KEY_MAX] = {false};

enum state {
    MENU, NIVEAU1, NIVEAU2, NIVEAU3, GAMEOVER, VICTOIRE
};

typedef struct {
    int x;
    int y;
    int tx;
    int ty;
    int v;
    bool actif;
} etoile;


void changestate(int*state,int newstate) {
    if (state==MENU){

    }
    else if (state=NIVEAU1) {

    }
    else if (state==NIVEAU2)    {

    }
    else if (state==NIVEAU3) {

    }
    else if (state== GAMEOVER) {

    }
    state=newstate;
    if (state==MENU){

    }
    else if (state=NIVEAU1) {

    }
    else if (state==NIVEAU2)    {

    }
    else if (state==NIVEAU3) {

    }
    else if (state== GAMEOVER) {

    }
    }


//ETOILES FONCTIONS :  A SUPPRIMER PAR LA SUITE UNE FOIS UNE IMAGE DE FOND SCROLLANT  CHOISI POUR LE JEU
void init_etoiles(etoile etoiles[]) {
    int i = 0;
    for (i = 0; i < NB_MAX_ETOILES; i++) {
        etoiles[i].v = 1;
        etoiles[i].actif = 1;
        etoiles[i].x = etoiles[i].tx + rand() % (SCREEN_WIDTH - (etoiles[i].tx * 2));
        etoiles[i].y = etoiles[i].ty + rand() % (SCREEN_HEIGHT - (etoiles[i].ty * 2));
        etoiles[i].tx = 1 + rand() % 2;
        etoiles[i].ty = etoiles[i].tx;
    }
}


void affiche_etoiles(etoile etoiles[]) {
    int i = 0;
    for (i = 0; i < NB_MAX_ETOILES; i++) {
        if (etoiles[i].actif) {
            al_draw_filled_ellipse(etoiles[i].x, etoiles[i].y, etoiles[i].tx, etoiles[i].ty,
                                   al_map_rgb(200 + rand() % 56, 200 + rand() % 56, 200 + rand() % 56));
        }
    }
}


void mouvement_etoiles(etoile etoiles[]) {
    int i = 0;
    for (i = 0; i < NB_MAX_ETOILES; i++) {
        if (etoiles[i].actif) {
            etoiles[i].x -= etoiles[i].v;
            etoiles[i].y -= etoiles[i].v * rand() % 1;
            if (etoiles[i].x - etoiles[i].tx < 0) {
                etoiles[i].actif = 0;
            }
        }
    }
}

void apparition_etoiles(etoile etoiles[]) {
    int i = 0;
    for (i = 0; i < NB_MAX_ETOILES; i++) {
        if (!etoiles[i].actif && rand() % 1000 < 2) {
            etoiles[i].x = SCREEN_WIDTH - etoiles[i].tx;
            etoiles[i].y = etoiles[i].ty + rand() % (SCREEN_HEIGHT - (etoiles[i].ty * 2));
            etoiles[i].actif = 1;
        }
    }
}



//ERREUR//
void erreur(const char *txt) {
    printf("ERREUR : %s", txt);
    exit(EXIT_FAILURE);
}
// FONCTIONS INFOS//


void affiche_infos(vaisseau vaisseau, ALLEGRO_FONT *font, ALLEGRO_FONT *fontBig, int GAMFPS, int gametime,int niveau,BOSSFINAL bossfinal) {
    if (vaisseau.vie <= 0) {
        al_play_sample(audioGameOver,1,0,1,ALLEGRO_PLAYMODE_ONCE,0);
        al_draw_textf(fontBig, al_map_rgb(255, 255, 0), SCREEN_WIDTH / 2,
                      SCREEN_HEIGHT / 2 - al_get_font_ascent(fontBig), ALLEGRO_ALIGN_CENTER, "Game Over");
        al_draw_textf(font, al_map_rgb(255, 255, 0), SCREEN_WIDTH / 2,
                      SCREEN_HEIGHT / 2 + al_get_font_ascent(fontBig), ALLEGRO_ALIGN_CENTER, "SCORE FINAL : %d",
                      vaisseau.score);
    } else if(vaisseau.vie > 0 ) {
        al_draw_textf(font, al_map_rgb(255, 255, 0), 20, 20, 0,
                      vaisseau.vie >=1 ? "%d Vies  -  Score : %d - FPS: %d Temps de jeu: %d" : "%d Vie   -  Score : %d", vaisseau.vie,
                      vaisseau.score,GAMFPS,gametime);
    } else if (vaisseau.vie >0 && niveau==3){
        al_draw_textf(font, al_map_rgb(255, 255, 0), 20, 20, 0,
                      vaisseau.vie >=1 ? "%d Vies  -  Score : %d - FPS: %d - Temps de jeu: %d - Boss vies :%d" : "%d Vie   -  Score : %d", vaisseau.vie,
                      vaisseau.score,GAMFPS,gametime,bossfinal.vie);
    }
}








// BACKGROUND FONCTIONS //



// MENU FONCTIONS


// EXPLOSIONS FONCTIONS

// BONUS FONCTIONS



// NIVEAU 1 FONCTIONS


// MENU FONCTIONS


// NIVEAU 2




// NIVEAU 3















//NIVEAUX TRANSITIONS FONCTIONS


int main() {


    int fin = 0, pause = 0, gameOver = 0, dessin = 0, waitInMilliseconds = -1, backmenu= 0,win=0;
    int frames=0; float Gamtime=0; int GameFps=0; int niveau=0;
    int *p=&niveau;

int state =-1;
    int key[KEY_MAX] = {0};
    int key2[KEY_MAX] = {0};


    ALLEGRO_DISPLAY *display;
    ALLEGRO_EVENT_QUEUE *queue;
    ALLEGRO_EVENT_QUEUE*back;
    ALLEGRO_TIMER *timer;
    ALLEGRO_FONT *fontBangers60;
    ALLEGRO_FONT *fontBangers160;
    ALLEGRO_BITMAP*BACKIMAGE = NULL;
    ALLEGRO_BITMAP*BACKIMAGE2 = NULL;
    ALLEGRO_BITMAP*BACKIMAGE3=NULL;
    ALLEGRO_BITMAP*BACKIMAGE4=NULL;
    ALLEGRO_BITMAP*BACKIMAGE5= NULL;
    ALLEGRO_BITMAP*BACKIMAGE6=NULL;
    ALLEGRO_BITMAP*BACKIMAGE7=NULL;
    ALLEGRO_BITMAP*BACKIMAGE8=NULL;
    ALLEGRO_BITMAP*BACKIMAGE9=NULL;
    ALLEGRO_BITMAP*EXPLOSION=NULL;
    ALLEGRO_BITMAP*TRANSITION=NULL;
    ALLEGRO_BITMAP*TRANSITION2=NULL;
    ALLEGRO_BITMAP*TRANSITION3=NULL;
    ALLEGRO_BITMAP*CREDITS=NULL;
    ALLEGRO_BITMAP*MENU=NULL;



    vaisseau vaisseau1;
    vaisseau vaisseau2;
    background BG;
    background BG2;
    background BG3;
    background BG4;
    background BG5;
    background BG6;
    background BG7;
    background BG8;
    background BG9;
    BONUS bonus[NB_MAX_BONUS];
    BONUS2 bonusv[NB_MAX_BONUS];
    explosion EXPLOSIONS[NB_MAX_EXPLOSIONS];
    missile missiles[NB_MAX_MISSILES];
    missile missiles2[NB_MAX_MISSILES];
    ennemi ennemis1[NB_MAX_ENNEMIS];
    ennemi ennemi2[NB_MAX_ENNEMIS];
    ennemi ennemi3[NB_MAX_ENNEMIS];
    ennemisfix ennemisfix3[NB_MAX_ENNEMIES_FIXES_LVL1];
    missile missileEnnemi1[NB_MAX_MISSILES];
    missile missileEnnemi2[NB_MAX_MISSILES];
    missile missileEnnemi3[NB_MAX_MISSILES];

    etoile etoiles[NB_MAX_ETOILES];
    ennemisfix ennemisFixes[NB_MAX_ENNEMIES_FIXES_LVL1];
    ennemisfix ennemisfix2[NB_MAX_ENNEMIES_FIXES_LVL1];
    BOSSFINAL boss;

    if (!al_init()) {
        erreur("Initialisation Allegro");
    }

    if (!al_install_keyboard()) {
        erreur("Installation clavier");
    }

    if (!al_init_primitives_addon()) {
        erreur("Initialisation primitives de dessin");
    }

    if (!al_init_font_addon()) {
        erreur("Initialisation polices");
    }

    if (!al_init_ttf_addon()) {
        erreur("Initialisation polices TTF");
    }

    if (!al_init_image_addon()) {
        erreur("Initialisation images");
    }

    if (!al_install_audio()){
        erreur("Initialisation SON");
    }
    if (!al_init_acodec_addon()){
        erreur("Initialisation SON ");
    }
    display = al_create_display(SCREEN_WIDTH, SCREEN_HEIGHT);
    if (!display) {
        erreur("Création de la fenêtre");
    }

    al_set_window_title(display, "SPACE ODDYSSEY");

    fontBangers60 = al_load_ttf_font("/Library/Fonts/BigCaslon.ttf", 60, 0);
    fontBangers160 = al_load_ttf_font("/Library/Fonts/BigCaslon.ttf", 160, 0);
    if (!fontBangers60 || !fontBangers160) {
        erreur("Chargement de la police bangers");
    }


    queue = al_create_event_queue();
    if (!queue) {
        erreur("Création de l'event queue");

    }
    back =al_create_event_queue();
    if (!back) {
        erreur("Création de l'event queue");
    }

    BACKIMAGE=al_load_bitmap("/Users/Yannisgoore/Downloads/waterbackground2.jpg");
    BACKIMAGE2=al_load_bitmap("/Users/Yannisgoore/Downloads/waterbackground2.jpg");
    BACKIMAGE3=al_load_bitmap("/Users/Yannisgoore/Downloads/waterbackground2.jpg");
    BACKIMAGE4=al_load_bitmap("/Users/Yannisgoore/Downloads/AB.png");
    BACKIMAGE5=al_load_bitmap("/Users/Yannisgoore/Downloads/AB.png");
    BACKIMAGE6=al_load_bitmap("/Users/Yannisgoore/Downloads/AB.png");
    BACKIMAGE7=al_load_bitmap("/Users/Yannisgoore/Downloads/FB.png");
    BACKIMAGE8=al_load_bitmap("/Users/Yannisgoore/Downloads/FB.png");
    BACKIMAGE9=al_load_bitmap("/Users/Yannisgoore/Downloads/FB.png");
    EXPLOSION= al_load_bitmap("/Users/Yannisgoore/Downloads/explosion.png");
    TRANSITION=al_load_bitmap("/Users/Yannisgoore/Downloads/transition1.jpg");
    TRANSITION2=al_load_bitmap("/Users/Yannisgoore/Downloads/TRANSITION.jpg");
    TRANSITION3=al_load_bitmap("/Users/Yannisgoore/Downloads/TRANSITIONF.jpg");

    init_background(&BG,0,0,1,0,2400,1200,-1,1,BACKIMAGE);
    init_background(&BG2,0,0,3,0,4800,1200,-1,1,BACKIMAGE2);
    init_background(&BG3,0,0,5,0,2400,1200,-1,1,BACKIMAGE3);
    init_background(&BG4,0,0,1,0,2400,1200,-1,1,BACKIMAGE4);
    init_background(&BG5,0,0,3,0,4800,1200,-1,1,BACKIMAGE5);
    init_background(&BG6,0,0,5,0,2400,1200,-1,1,BACKIMAGE6);
    init_background(&BG7,0,0,1,0,2400,1200,-1,1,BACKIMAGE7);
    init_background(&BG8,0,0,3,0,4800,1200,-1,1,BACKIMAGE8);
    init_background(&BG9,0,0,5,0,2400,1200,-1,1,BACKIMAGE9);


    MENU=al_load_bitmap("/users/Yannisgoore/Downloads/menututo.jpg");







    timer = al_create_timer(1.0/60);
    if (!timer) {
        erreur("Création du timer");
    }
    al_start_timer(timer);


    al_register_event_source(queue, al_get_display_event_source(display));
    al_register_event_source(queue, al_get_keyboard_event_source());
    al_register_event_source(queue, al_get_timer_event_source(timer));
    affichermenu(queue,fontBangers160,MENU,SCREEN_WIDTH/550,SCREEN_HEIGHT/550,p);
    al_start_timer(timer);
    Gamtime=al_current_time();

    init_vaisseau(&vaisseau1);
    init_vaisseau(&vaisseau2);
    al_set_target_backbuffer(display);
    init_missiles(missiles);
    init_missiles(missileEnnemi1);
    init_missiles(missileEnnemi2);
    init_missiles(missileEnnemi3);
    init_ennemis(ennemis1,ennemisFixes,&boss,1);
    init_ennemis(ennemi2,ennemisfix2,&boss,2);
    init_ennemis(ennemi3,ennemisfix3,&boss,3);
    init_BONUS(bonus,bonusv,2);

    //ALLEGRO_EVENT event;

    initExplosions(EXPLOSIONS,NB_MAX_EXPLOSIONS,EXPLOSION);
    if (niveau==0)
    {
niveau=1;
    }


    if (niveau==1)
    {
        al_clear_to_color(NOIR);
        al_draw_bitmap(TRANSITION,SCREEN_WIDTH/550,SCREEN_HEIGHT/550,0);
        al_flip_display();
        al_rest(5);
        do {

            ALLEGRO_EVENT event = {0};

            al_wait_for_event(queue, &event);

            if (event.type == ALLEGRO_EVENT_DISPLAY_CLOSE) {
                al_destroy_sample(audioGameOver);
                al_destroy_sample(audioTir);
                al_destroy_sample(audioBonus);
                al_destroy_sample(audioExplosion);
                al_destroy_bitmap(vaisseau1.image);
                al_destroy_font(fontBangers60);
                al_destroy_font(fontBangers160);
                al_destroy_event_queue(queue);
                al_destroy_display(display);
                al_destroy_timer(timer);
                al_destroy_bitmap(BACKIMAGE);
                al_destroy_bitmap(BACKIMAGE2);
                al_destroy_bitmap(BACKIMAGE3);
                al_destroy_bitmap(MENU);
                return 0;
            } else if (event.type == ALLEGRO_EVENT_KEY_DOWN && !pause && waitInMilliseconds == -1) {
                switch (event.keyboard.keycode) {
                    case ALLEGRO_KEY_UP:
                    case ALLEGRO_KEY_W: // Z
                        key[UP] = 1;
                        break;
                    case ALLEGRO_KEY_DOWN:
                    case ALLEGRO_KEY_S:
                        key[DOWN] = 1;
                        break;
                    case ALLEGRO_KEY_LEFT:
                    case ALLEGRO_KEY_A: // Q
                        key[LEFT] = 1;
                        break;
                    case ALLEGRO_KEY_RIGHT:
                    case ALLEGRO_KEY_D:
                        key[RIGHT] = 1;
                        break;
                    case ALLEGRO_KEY_SPACE:
                        lancement_missile(&vaisseau1, missiles);

                        break;
                }
            } else if (event.type == ALLEGRO_EVENT_KEY_UP && waitInMilliseconds == -1) {
                switch (event.keyboard.keycode) {
                    case ALLEGRO_KEY_UP:
                    case ALLEGRO_KEY_W: // Z
                        key[UP] = 0;
                        break;
                    case ALLEGRO_KEY_DOWN:
                    case ALLEGRO_KEY_S:
                        key[DOWN] = 0;
                        break;
                    case ALLEGRO_KEY_LEFT:
                    case ALLEGRO_KEY_A: // Q
                        key[LEFT] = 0;
                        break;
                    case ALLEGRO_KEY_RIGHT:
                    case ALLEGRO_KEY_D:
                        key[RIGHT] = 0;
                        break;
                    case ALLEGRO_KEY_ESCAPE:
                        fin = 1;
                        break;
                    case ALLEGRO_KEY_P:
                        key[UP] = 0;
                        key[DOWN] = 0;
                        key[LEFT] = 0;
                        key[RIGHT] = 0;
                        pause = !pause;
                        dessin = 1;
                        break;
                }
            } else if (event.type == ALLEGRO_EVENT_TIMER) {
                uptade_background(&BG);
                uptade_background(&BG2);
                uptade_background(&BG3);
                frames++;
                if (al_current_time()- Gamtime >=1){
                    Gamtime=al_current_time();
                    GameFps = frames;
                    frames = 0;
                    frames=0;
                    if(Gamtime>=25.0){
                        fin=1;
                        niveau = 2;
                    }

                }


                if (waitInMilliseconds > 0) {
                    waitInMilliseconds--;
                    dessin = 1;

                }
                else if (!pause) {
                    if (key[UP]) {
                        monte(&vaisseau1);
                    }
                    if (key[DOWN]) {
                        descend(&vaisseau1);
                    }
                    if (key[LEFT]) {
                        gauche(&vaisseau1);
                    }
                    if (key[RIGHT]) {
                        droite(&vaisseau1);
                    }

                    updateExplosions(EXPLOSIONS,NB_MAX_EXPLOSIONS);
                    lancement_missileEnnemi(ennemisFixes,missileEnnemi1);
                    startbonusVIE(bonus);
                    startbonusVites(bonusv);


                    apparition_ennemis(ennemis1);
                    apparition_etoiles(etoiles);

                    mouvement_ennemis(ennemis1);
                    mouvement_etoiles(etoiles);

                    avance_missiles(missiles);
                    avance_missileE(missileEnnemi1);
                    //collisionbonusvie(bonus,&vaisseau);
                    collison_missilLEnnemi_VAISSEAU(missileEnnemi1,&vaisseau1,EXPLOSIONS);
                    collision_missile(missiles, ennemis1, &vaisseau1,EXPLOSIONS,&boss);
                    collision_missille_vaisseau_ennemisfixes(missiles,&vaisseau1,EXPLOSIONS,ennemisFixes);
                    collision_vaisseau(&vaisseau1, ennemis1,EXPLOSIONS);


                    if (vaisseau1.vie <= 0) {
                        gameOver = 1;
                    }

                    dessin = 1;
                }
            }

            if (gameOver) {
                if (waitInMilliseconds == -1) {
                    waitInMilliseconds = 5 * 60;
                } else if (waitInMilliseconds == 0) {
                    vaisseau1.vie = 3;
                    vaisseau1.score = 0;
                    gameOver = 0;
                    key[UP] = 0;
                    key[DOWN] = 0;
                    key[LEFT] = 0;
                    key[RIGHT] = 0;
                    waitInMilliseconds = -1;
                }
            }

            if (dessin && al_is_event_queue_empty(queue)) {
                al_clear_to_color(NOIR);



                dessiner_background(&BG);
                dessiner_background(&BG2);
                dessiner_background(&BG3);
                affiche_infos(vaisseau1, fontBangers60, fontBangers160,GameFps,Gamtime,1,boss);
                affichebonusVIE(bonus);
                drawExplosions(EXPLOSIONS,NB_MAX_EXPLOSIONS);
                affiche_ennemisfix(ennemisFixes);
                drawmissileEnnemi(missileEnnemi1);
                affiche_ennemis(ennemis1);
                affiche_missiles(missiles);
                affiche_vaisseau(&vaisseau1);





                if (pause) {
                    al_draw_textf(fontBangers160, al_map_rgb(255, 255, 0), SCREEN_WIDTH / 2,
                                  SCREEN_HEIGHT / 2 , ALLEGRO_ALIGN_CENTER, "Pause");

                }

                if (gameOver) {
                    al_draw_textf(fontBangers60, al_map_rgb(255, 255, 0), SCREEN_WIDTH / 2,
                                  SCREEN_HEIGHT , ALLEGRO_ALIGN_CENTER,
                                  (waitInMilliseconds / 60) + 1 > 1 ? "Nouvelle partie dans %d secondes..." : "Nouvelle partie dans %d seconde...", (waitInMilliseconds / 60) + 1);
                }

                al_flip_display();

                dessin = 0;



            }

        } while (!fin);
        printf("******FIN*****");

/*
        //Libération de la mémoire allouée dynamiquement :

        //al_destroy_bitmap(ennemis->image);
        for (int i = 0; i < NB_MAX_EXPLOSIONS; ++i) {
            al_destroy_bitmap(EXPLOSIONS[i].image);
            printf(" carre %d",i);
        }
        for (int j = 0; j <NB_MAX_ENNEMIS ; ++j) {
            al_destroy_bitmap(ennemis1[j].image);
            printf(" carre %d",j);
        }
        for (int k = 0; k < NB_MAX_ENNEMIES_FIXES_LVL1; ++k) {
            al_destroy_bitmap(ennemisFixes[k].image);
            printf(" carre %d",k);


        }

        for (int f = 0; f < NB_MAX_BONUS; ++f) {
            al_destroy_bitmap(bonus[f].image);

        }
*/

    }


    if (niveau==2) {
        fin = 0;
        al_clear_to_color(NOIR);
        al_draw_bitmap(TRANSITION2,SCREEN_WIDTH/550,SCREEN_HEIGHT/550,0);
        al_flip_display();
        al_rest(5);

        do {

            ALLEGRO_EVENT event = {0};

            al_wait_for_event(queue, &event);

            if (event.type == ALLEGRO_EVENT_DISPLAY_CLOSE) {
                fin = 1;
            } else if (event.type == ALLEGRO_EVENT_KEY_DOWN && !pause && waitInMilliseconds == -1) {
                switch (event.keyboard.keycode) {
                    case ALLEGRO_KEY_UP:
                    case ALLEGRO_KEY_W: // Z
                        key[UP] = 1;
                        break;
                    case ALLEGRO_KEY_DOWN:
                    case ALLEGRO_KEY_S:
                        key[DOWN] = 1;
                        break;
                    case ALLEGRO_KEY_LEFT:
                    case ALLEGRO_KEY_A: // Q
                        key[LEFT] = 1;
                        break;
                    case ALLEGRO_KEY_RIGHT:
                    case ALLEGRO_KEY_D:
                        key[RIGHT] = 1;
                        break;
                    case ALLEGRO_KEY_SPACE:
                        lancement_missile(&vaisseau1, missiles);

                        break;
                }
            } else if (event.type == ALLEGRO_EVENT_KEY_UP && waitInMilliseconds == -1) {
                switch (event.keyboard.keycode) {
                    case ALLEGRO_KEY_UP:
                    case ALLEGRO_KEY_W: // Z
                        key[UP] = 0;
                        break;
                    case ALLEGRO_KEY_DOWN:
                    case ALLEGRO_KEY_S:
                        key[DOWN] = 0;
                        break;
                    case ALLEGRO_KEY_LEFT:
                    case ALLEGRO_KEY_A: // Q
                        key[LEFT] = 0;
                        break;
                    case ALLEGRO_KEY_RIGHT:
                    case ALLEGRO_KEY_D:
                        key[RIGHT] = 0;
                        break;
                    case ALLEGRO_KEY_ESCAPE:
                        fin = 1;
                        break;
                    case ALLEGRO_KEY_P:
                        key[UP] = 0;
                        key[DOWN] = 0;
                        key[LEFT] = 0;
                        key[RIGHT] = 0;
                        pause = !pause;
                        dessin = 1;
                        break;
                }
            } else if (event.type == ALLEGRO_EVENT_TIMER) {
                uptade_background(&BG4);
                uptade_background(&BG5);
                uptade_background(&BG6);
                frames++;
                if (al_current_time()- Gamtime >=1){
                    Gamtime=al_current_time();
                    GameFps = frames;
                    frames = 0;
                    frames=0;

                }


                if (waitInMilliseconds > 0) {
                    waitInMilliseconds--;
                    dessin = 1;

                }
                else if (!pause) {
                    if (key[UP]) {
                        monte(&vaisseau1);
                    }
                    if (key[DOWN]) {
                        descend(&vaisseau1);
                    }
                    if (key[LEFT]) {
                        gauche(&vaisseau1);
                    }
                    if (key[RIGHT]) {
                        droite(&vaisseau1);
                    }

                    updateExplosions(EXPLOSIONS,NB_MAX_EXPLOSIONS);

                    startbonusVIE(bonus);
                    startbonusVites(bonusv);

                    apparition_ennemis(ennemi2);
                    apparition_etoiles(etoiles);

                    mouvement_ennemis(ennemi2);
                    mouvement_etoiles(etoiles);
                    avance_missiles(missiles);
                    collisionbonusvie(bonus,&vaisseau1);
                    collision_missile_NIV2(missiles, ennemi2, &vaisseau1,EXPLOSIONS,&boss);
                    collision_missille_vaisseau_ennemisfixes(missiles,&vaisseau1,EXPLOSIONS,ennemisfix2);
                    collision_vaisseau(&vaisseau1, ennemi2,EXPLOSIONS);


                    if (vaisseau1.vie <= 0) {
                        gameOver = 1;
                    }

                    dessin = 1;
                }
            }

            if (gameOver) {
                if (waitInMilliseconds == -1) {
                    waitInMilliseconds = 5 * 60;
                } else if (waitInMilliseconds == 0) {
                    vaisseau1.vie = 3;
                    vaisseau1.score = 0;
                    gameOver = 0;
                    key[UP] = 0;
                    key[DOWN] = 0;
                    key[LEFT] = 0;
                    key[RIGHT] = 0;
                    waitInMilliseconds = -1;
                }
            }

            if (dessin && al_is_event_queue_empty(queue)) {
                al_clear_to_color(NOIR);



                dessiner_background(&BG4);
                dessiner_background(&BG5);
                dessiner_background(&BG6);
                affiche_infos(vaisseau1, fontBangers60, fontBangers160,GameFps,Gamtime,2,boss);
                affichebonusVIE(bonus);
                drawExplosions(EXPLOSIONS,NB_MAX_EXPLOSIONS);
                affiche_etoiles(etoiles);
                affiche_ennemis(ennemi2);
                affiche_ennemisfix(ennemisfix2);
                affiche_missiles(missiles);
                affiche_vaisseau(&vaisseau1);





                if (pause) {
                    al_draw_textf(fontBangers160, al_map_rgb(255, 255, 0), SCREEN_WIDTH / 2,
                                  SCREEN_HEIGHT / 2 , ALLEGRO_ALIGN_CENTER, "Pause");

                }

                if (gameOver) {
                    al_draw_textf(fontBangers60, al_map_rgb(255, 255, 0), SCREEN_WIDTH / 2,
                                  SCREEN_HEIGHT , ALLEGRO_ALIGN_CENTER,
                                  (waitInMilliseconds / 60) + 1 > 1 ? "Nouvelle partie dans %d secondes..." : "Nouvelle partie dans %d seconde...", (waitInMilliseconds / 60) + 1);
                }

                al_flip_display();

                dessin = 0;



            }

        } while (!fin);


        //Libération de la mémoire allouée dynamiquement :

        //al_destroy_bitmap(ennemis->image);
        for (int i = 0; i < NB_MAX_EXPLOSIONS; ++i) {
            al_destroy_bitmap(EXPLOSIONS[i].image);
            printf(" carre %d",i);
        }
        for (int i = 0; i <NB_MAX_ENNEMIS ; ++i) {
            al_destroy_bitmap(ennemi2[i].image);
            printf(" carre %d",i);
        }
        for (int i = 0; i< NB_MAX_ENNEMIES_FIXES_LVL1; ++i) {
            al_destroy_bitmap(ennemisfix2[i].image);
            printf(" carre %d",i);


        }

        for (int i = 0; i < NB_MAX_BONUS; ++i) {
            al_destroy_bitmap(bonus[i].image);

        }
        al_destroy_sample(audioGameOver);
        al_destroy_sample(audioTir);
        al_destroy_sample(audioBonus);
        al_destroy_sample(audioExplosion);
        al_destroy_bitmap(vaisseau1.image);
        al_destroy_font(fontBangers60);
        al_destroy_font(fontBangers160);
        al_destroy_event_queue(queue);
        al_destroy_display(display);
        al_destroy_timer(timer);
        al_destroy_bitmap(BACKIMAGE4);
        al_destroy_bitmap(BACKIMAGE5);
        al_destroy_bitmap(BACKIMAGE6);
        al_destroy_bitmap(MENU);

    }
    else if (niveau==3) {
        al_clear_to_color(NOIR);
        al_draw_bitmap(TRANSITION3,SCREEN_WIDTH/550,SCREEN_HEIGHT/550,0);
        al_flip_display();
        al_rest(5);

        do {

            ALLEGRO_EVENT event = {0};

            al_wait_for_event(queue, &event);

            if (event.type == ALLEGRO_EVENT_DISPLAY_CLOSE) {
                fin = 1;
            } else if (event.type == ALLEGRO_EVENT_KEY_DOWN && !pause && waitInMilliseconds == -1) {
                switch (event.keyboard.keycode) {
                    case ALLEGRO_KEY_UP:
                    case ALLEGRO_KEY_W: // Z
                        key[UP] = 1;
                        break;
                    case ALLEGRO_KEY_DOWN:
                    case ALLEGRO_KEY_S:
                        key[DOWN] = 1;
                        break;
                    case ALLEGRO_KEY_LEFT:
                    case ALLEGRO_KEY_A: // Q
                        key[LEFT] = 1;
                        break;
                    case ALLEGRO_KEY_RIGHT:
                    case ALLEGRO_KEY_D:
                        key[RIGHT] = 1;
                        break;
                    case ALLEGRO_KEY_SPACE:
                        lancement_missile(&vaisseau1, missiles);

                        break;
                }
            } else if (event.type == ALLEGRO_EVENT_KEY_UP && waitInMilliseconds == -1) {
                switch (event.keyboard.keycode) {
                    case ALLEGRO_KEY_UP:
                    case ALLEGRO_KEY_W: // Z
                        key[UP] = 0;
                        break;
                    case ALLEGRO_KEY_DOWN:
                    case ALLEGRO_KEY_S:
                        key[DOWN] = 0;
                        break;
                    case ALLEGRO_KEY_LEFT:
                    case ALLEGRO_KEY_A: // Q
                        key[LEFT] = 0;
                        break;
                    case ALLEGRO_KEY_RIGHT:
                    case ALLEGRO_KEY_D:
                        key[RIGHT] = 0;
                        break;
                    case ALLEGRO_KEY_ESCAPE:
                        fin = 1;
                        break;
                    case ALLEGRO_KEY_P:
                        key[UP] = 0;
                        key[DOWN] = 0;
                        key[LEFT] = 0;
                        key[RIGHT] = 0;
                        pause = !pause;
                        dessin = 1;
                        break;
                }
            } else if (event.type == ALLEGRO_EVENT_TIMER) {
                uptade_background(&BG7);
                uptade_background(&BG8);
                uptade_background(&BG9);
                frames++;
                if (al_current_time()- Gamtime >=1){
                    Gamtime=al_current_time();
                    GameFps = frames;
                    frames = 0;
                    frames=0;

                }


                if (waitInMilliseconds > 0) {
                    waitInMilliseconds--;
                    dessin = 1;

                }
                else if (!pause) {
                    if (key[UP]) {
                        monte(&vaisseau1);
                    }
                    if (key[DOWN]) {
                        descend(&vaisseau1);
                    }
                    if (key[LEFT]) {
                        gauche(&vaisseau1);
                    }
                    if (key[RIGHT]) {
                        droite(&vaisseau1);
                    }

                    updateExplosions(EXPLOSIONS,NB_MAX_EXPLOSIONS);

                    startbonusVIE(bonus);
                    startbonusVites(bonusv);

                    apparition_ennemis(ennemi3);
                    mouvementBOSS(&boss);
                    mouvement_ennemis(ennemi3);
                    avance_missiles(missiles);
                    collisionbonusvie(bonus,&vaisseau1);
                    collision_missile_NIV2(missiles, ennemi3, &vaisseau1,EXPLOSIONS,&boss);
                    collision_missille_vaisseau_ennemisfixes(missileEnnemi3,&vaisseau1,EXPLOSIONS,ennemisfix3);
                    collision_vaisseau(&vaisseau1, ennemi3,EXPLOSIONS);


                    if (vaisseau1.vie <= 0) {
                        gameOver = 1;
                    }

                    dessin = 1;
                }
            }

            if (gameOver) {
                if (waitInMilliseconds == -1) {
                    waitInMilliseconds = 5 * 60;
                } else if (waitInMilliseconds == 0) {
                    vaisseau1.vie = 3;
                    vaisseau1.score = 0;
                    gameOver = 0;
                    key[UP] = 0;
                    key[DOWN] = 0;
                    key[LEFT] = 0;
                    key[RIGHT] = 0;
                    waitInMilliseconds = -1;
                }
            }

            if (dessin && al_is_event_queue_empty(queue)) {
                al_clear_to_color(NOIR);



                dessiner_background(&BG7);
                dessiner_background(&BG8);
                dessiner_background(&BG9);
                affiche_infos(vaisseau1, fontBangers60, fontBangers160,GameFps,Gamtime,3,boss);
                affichebonusVIE(bonus);
                drawExplosions(EXPLOSIONS,NB_MAX_EXPLOSIONS);
                affiche_ennemis(ennemi3);
                affiche_ennemisfix(ennemisfix3);

                affiche_missiles(missiles);
                affiche_vaisseau(&vaisseau1);
                drawBOSS(&boss);




                if (pause) {
                    al_draw_textf(fontBangers160, al_map_rgb(255, 255, 0), SCREEN_WIDTH / 2,
                                  SCREEN_HEIGHT / 2 , ALLEGRO_ALIGN_CENTER, "Pause");

                }

                if (gameOver) {
                    al_draw_textf(fontBangers60, al_map_rgb(255, 255, 0), SCREEN_WIDTH / 2,
                                  SCREEN_HEIGHT , ALLEGRO_ALIGN_CENTER,
                                  (waitInMilliseconds / 60) + 1 > 1 ? "Nouvelle partie dans %d secondes..." : "Nouvelle partie dans %d seconde...", (waitInMilliseconds / 60) + 1);
                }

                al_flip_display();

                dessin = 0;



            }

        } while (!fin);


        //Libération de la mémoire allouée dynamiquement :

        //al_destroy_bitmap(ennemis->image);
        for (int i = 0; i < NB_MAX_EXPLOSIONS; ++i) {
            al_destroy_bitmap(EXPLOSIONS[i].image);
            printf(" carre %d",i);
        }
        for (int j = 0; j <NB_MAX_ENNEMIS ; ++j) {
            al_destroy_bitmap(ennemi3[j].image);
            printf(" carre %d",j);
        }
        for (int k = 0; k < NB_MAX_ENNEMIES_FIXES_LVL1; ++k) {
            al_destroy_bitmap(ennemisfix3[k].image);
            printf(" carre %d",k);


        }

        for (int f = 0; f < NB_MAX_BONUS; ++f) {
            al_destroy_bitmap(bonus[f].image);

        }

        al_destroy_sample(audioGameOver);
        al_destroy_sample(audioTir);
        al_destroy_sample(audioBonus);
        al_destroy_sample(audioExplosion);
        al_destroy_bitmap(vaisseau1.image);
        al_destroy_font(fontBangers60);
        al_destroy_font(fontBangers160);
        al_destroy_event_queue(queue);
        al_destroy_display(display);
        al_destroy_timer(timer);
        al_destroy_bitmap(BACKIMAGE7);
        al_destroy_bitmap(BACKIMAGE8);
        al_destroy_bitmap(BACKIMAGE9);
        al_destroy_bitmap(MENU);


    } else if (niveau==4){

        do {

            ALLEGRO_EVENT event = {0};

            al_wait_for_event(queue, &event);

            if (event.type == ALLEGRO_EVENT_DISPLAY_CLOSE) {
                fin = 1;
            } else if (event.type == ALLEGRO_EVENT_KEY_DOWN && !pause && waitInMilliseconds == -1) {
                switch (event.keyboard.keycode) {
                    case ALLEGRO_KEY_UP:
                        key[UP] = 1;
                        break;
                    case ALLEGRO_KEY_W: // Z
                        key2[UP]=1;
                        break;
                    case ALLEGRO_KEY_DOWN:
                        key[DOWN] = 1;
                        break;
                    case ALLEGRO_KEY_S:
                        key2[DOWN] = 1;
                        break;

                    case ALLEGRO_KEY_LEFT:
                        key[LEFT] = 1;
                        break;

                    case ALLEGRO_KEY_A: // Q
                        key2[LEFT] = 1;
                        break;
                    case ALLEGRO_KEY_RIGHT:
                        key[RIGHT] = 1;
                        break;
                    case ALLEGRO_KEY_D:
                        key2[RIGHT] = 1;
                        break;

                    case ALLEGRO_KEY_SPACE:
                        lancement_missile(&vaisseau1, missiles);

                    case ALLEGRO_KEY_G:
                        lancement_missile(&vaisseau2,missiles2);
                        break;
                }
            }
            else if (event.type == ALLEGRO_EVENT_KEY_UP && waitInMilliseconds == -1) {
                switch (event.keyboard.keycode) {
                    case ALLEGRO_KEY_UP:
                        key[UP] = 0;
                        break;
                    case ALLEGRO_KEY_Z:
                        key2[UP] = 0;
                        break;
                    case ALLEGRO_KEY_DOWN:
                        key[DOWN]=0;
                    case ALLEGRO_KEY_S:
                        key2[DOWN] = 0;
                        break;
                    case ALLEGRO_KEY_LEFT:
                        key[LEFT]=0;

                    case ALLEGRO_KEY_Q:
                        key2[LEFT] = 0;
                        break;
                    case ALLEGRO_KEY_RIGHT:
                        key[RIGHT]= 0;
                        break;

                    case ALLEGRO_KEY_D:
                        key2[RIGHT] = 0;
                        break;
                    case ALLEGRO_KEY_ESCAPE:
                        al_destroy_sample(audioGameOver);
                        al_destroy_sample(audioTir);
                        al_destroy_sample(audioBonus);
                        al_destroy_sample(audioExplosion);
                        al_destroy_bitmap(vaisseau1.image);
                        al_destroy_bitmap(vaisseau2.image);
                        al_destroy_font(fontBangers60);
                        al_destroy_font(fontBangers160);
                        al_destroy_event_queue(queue);
                        al_destroy_display(display);
                        al_destroy_timer(timer);
                        al_destroy_bitmap(BACKIMAGE);
                        al_destroy_bitmap(BACKIMAGE2);
                        al_destroy_bitmap(BACKIMAGE3);
                        al_destroy_bitmap(MENU);
//Libération de la mémoire allouée dynamiquement :

//al_destroy_bitmap(ennemis->image);
                        for (int i = 0; i < NB_MAX_EXPLOSIONS; ++i) {
                            al_destroy_bitmap(EXPLOSIONS[i].image);
                            printf(" carre %d",i);
                        }
                        for (int j = 0; j <NB_MAX_ENNEMIS ; ++j) {
                            al_destroy_bitmap(ennemis1[j].image);
                            printf(" carre %d",j);
                        }
                        for (int k = 0; k < NB_MAX_ENNEMIES_FIXES_LVL1; ++k) {
                            al_destroy_bitmap(ennemisFixes[k].image);
                            printf(" carre %d",k);


                        }

                        for (int f = 0; f < NB_MAX_BONUS; ++f) {
                            al_destroy_bitmap(bonus[f].image);

                        }
                        fin = 1;
                        break;
                    case ALLEGRO_KEY_P:
                        key[UP] = 0;
                        key[DOWN] = 0;
                        key[LEFT] = 0;
                        key[RIGHT] = 0;
                        key2[UP] = 0;
                        key2[DOWN] = 0;
                        key2[LEFT] = 0;
                        key2[RIGHT] = 0;
                        pause = !pause;
                        dessin = 1;
                        break;
                }
            } else if (event.type == ALLEGRO_EVENT_TIMER) {
                uptade_background(&BG);
                uptade_background(&BG2);
                uptade_background(&BG3);
                frames++;
                if (al_current_time()- Gamtime >=1){
                    Gamtime=al_current_time();
                    GameFps = frames;
                    frames=0;
                    frames=0;
                    if(Gamtime>=25.0){
                        fin=1;
                        niveau = 2;
                    }

                }


                if (waitInMilliseconds > 0) {
                    waitInMilliseconds--;
                    dessin = 1;

                }
                else if (!pause) {
                    if (key[UP]) {
                        monte(&vaisseau1);
                    }
                    if (key2[UP]) {
                        monte(&vaisseau2);
                    }

                    if (key[DOWN]) {
                        descend(&vaisseau1);
                    }
                    if (key2[DOWN]) {
                        descend(&vaisseau2);
                    }
                    if (key[LEFT]) {
                        gauche(&vaisseau1);
                    }
                    if (key2[LEFT]) {
                        gauche(&vaisseau2);
                    }
                    if (key[RIGHT]) {
                        droite(&vaisseau1);
                    }
                    if (key2[RIGHT]) {
                        droite(&vaisseau2);
                    }


                    updateExplosions(EXPLOSIONS,NB_MAX_EXPLOSIONS);

                    startbonusVIE(bonus);
                    startbonusVites(bonusv);


                    apparition_ennemis(ennemis1);

                    mouvement_ennemis(ennemis1);
                    mouvement_etoiles(etoiles);

                    avance_missiles(missiles);
                    avance_missiles(missiles2);
                    avance_missileE(missileEnnemi1);
//collisionbonusvie(bonus,&vaisseau);
                    collisionbonusvie(bonus,&vaisseau2);
                    collison_missilLEnnemi_VAISSEAU(missileEnnemi1,&vaisseau1,EXPLOSIONS);
                    collison_missilLEnnemi_VAISSEAU(missileEnnemi1,&vaisseau2,EXPLOSIONS);
                    collision_missile(missiles, ennemis1, &vaisseau1,EXPLOSIONS,&boss);
                    collision_missile(missiles, ennemis1, &vaisseau2,EXPLOSIONS,&boss);
                    collision_missille_vaisseau_ennemisfixes(missiles,&vaisseau1,EXPLOSIONS,ennemisFixes);
                    collision_missille_vaisseau_ennemisfixes(missiles2,&vaisseau2,EXPLOSIONS,ennemisFixes);
                    collision_vaisseau(&vaisseau1, ennemis1,EXPLOSIONS);
                    collision_vaisseau(&vaisseau2, ennemis1,EXPLOSIONS);


                    if (vaisseau1.vie <= 0 || vaisseau2.vie<=0 ) {
                        gameOver = 1;
                    }

                    dessin = 1;
                }
            }

            if (gameOver) {
                if (waitInMilliseconds == -1) {
                    waitInMilliseconds = 5 * 60;
                } else if (waitInMilliseconds == 0) {
                    vaisseau1.vie = 3;
                    vaisseau1.score = 0;
                    gameOver = 0;
                    key[UP] = 0;
                    key[DOWN] = 0;
                    key[LEFT] = 0;
                    key[RIGHT] = 0;
                    vaisseau2.vie = 3;
                    vaisseau2.score = 0;
                    gameOver = 0;
                    key2[UP] = 0;
                    key2[DOWN] = 0;
                    key2[LEFT] = 0;
                    key2[RIGHT] = 0;

                    waitInMilliseconds = -1;
                }
            }

            if (dessin && al_is_event_queue_empty(queue)) {
                al_clear_to_color(NOIR);



                dessiner_background(&BG);
                dessiner_background(&BG2);
                dessiner_background(&BG3);
                affiche_infos(vaisseau1, fontBangers60, fontBangers160,GameFps,Gamtime,1,boss);
                affichebonusVIE(bonus);
                drawExplosions(EXPLOSIONS,NB_MAX_EXPLOSIONS);
                affiche_ennemisfix(ennemisFixes);
                drawmissileEnnemi(missileEnnemi1);
                affiche_ennemis(ennemis1);
                affiche_missiles(missiles);
                affiche_missiles(missiles2);
                affiche_vaisseau(&vaisseau1);
                affiche_vaisseau(&vaisseau2);




                if (pause) {
                    al_draw_textf(fontBangers160, al_map_rgb(255, 255, 0), SCREEN_WIDTH / 2,
                                  SCREEN_HEIGHT / 2 , ALLEGRO_ALIGN_CENTER, "Pause");

                }

                if (gameOver) {
                    al_draw_textf(fontBangers60, al_map_rgb(255, 255, 0), SCREEN_WIDTH / 2,
                                  SCREEN_HEIGHT , ALLEGRO_ALIGN_CENTER,
                                  (waitInMilliseconds / 60) + 1 > 1 ? "Nouvelle partie dans %d secondes..." : "Nouvelle partie dans %d seconde...", (waitInMilliseconds / 60) + 1);
                }

                al_flip_display();

                dessin = 0;



            }
                }while(!fin);

    }





    return 0;
}







