//
// Created by Yannis Goore on 2019-05-09.
//
#include <stdio.h>
#include <time.h>
#include <allegro5/allegro.h>
#include <stdbool.h>
#include <allegro5/allegro_primitives.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_image.h>
#include <allegro5/allegro_audio.h>
#include "vaisseau.h"
#define NB_MAX_ETOILES 250
#define SCREEN_WIDTH 2400
#define SCREEN_HEIGHT 1200
#define NOIR al_map_rgb(0,0,0)
#define NB_MAX_ENNEMIS 10
#define NB_MAX_MISSILES 12
#define NB_MAX_EXPLOSIONS 10
#define NB_MAX_BONUS 5
#define NB_MAX_ENNEMIES_FIXES_LVL1  10

#ifndef ALEGROCARRE_BONUS_H
#define ALEGROCARRE_BONUS_H
typedef  struct {
    int x;
    int y;
    int tx;
    int ty;
    bool actif;
    ALLEGRO_BITMAP*image;
}BONUS;
typedef  struct {
    int x;
    int y;
    int tx;
    int ty;
    bool actif;
    ALLEGRO_BITMAP*image;
}BONUS2;
void init_BONUS(BONUS bonus[],BONUS2 bonusV[],int niveau);
void startbonusVites(BONUS2 bonus[] );
void collisionbonusvites(BONUS2 bonus[],vaisseau*vaisseau);
void collisionbonusvie(BONUS bonus[],vaisseau*vaisseau);
void startbonusVIE(BONUS bonus[]);
void  affichebonusVIE(BONUS bonus[]);
void affichebonusV(BONUS2 bonus []);
#endif //ALEGROCARRE_BONUS_H
