//
// Created by Yannis Goore on 2019-05-09.
//
#include <allegro5/allegro.h>
#include <stdio.h>
#include <time.h>
#include <allegro5/allegro.h>
#include <stdbool.h>
#include <allegro5/allegro_primitives.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_image.h>
#include <allegro5/allegro_audio.h>
#include "ennemis.h"
#include "Explosion.h"
#ifndef ALEGROCARRE_VAISSEAU_H


#define ALEGROCARRE_VAISSEAU_H
typedef struct {
    int x;
    int y;
    int tx;
    int ty;
    int v;
    int vie;
    int score;
    ALLEGRO_BITMAP *image;
} vaisseau;
void init_vaisseau(vaisseau *vaisseau);
void affiche_vaisseau(vaisseau *vaisseau);
void monte(vaisseau *vaisseau);
void descend(vaisseau *vaisseau);
void gauche(vaisseau *vaisseau);
void droite(vaisseau *vaisseau);
void collision_vaisseau(vaisseau *vaisseau, ennemi ennemis[], explosion explosions[]);
#endif //ALEGROCARRE_VAISSEAU_H
